﻿$MSIXVhdxSrc="\\mst.intra\dfs\MSIXAppAttach\VLC.VHDX"             #Anpassen
$ParentFolder = "MSIX"
$MSIXmgrPath = "C:\temp\MSIX App Attach STARTER-KIT\MSIXmgr\x64"  #Anpassen
$MSIXPath = "\\mst.intra\dfs\MSIXStore\"                          #Anpassen
$PackageName = "VLC-Player-3.0.11-x64_1.0.0.0_x64__cqfpzfs0pq22w" #Anpassen
$PackagePath = $MSIXPath + $PackageName + ".msix"
$Parts = $PackageName.split("_")
$VolumeName = "MSIX-" + $Parts[0]


#Generate a MSIX App Attach Container (VHDX) for MSIX
New-VHD -SizeBytes 2048MB -Path $MSIXVhdxSrc -Dynamic -Confirm:$false 
$VHDObject = Mount-VHD $MSIXVhdxSrc -Passthru
$Disk = Initialize-Disk -Passthru -Number $VHDObject.Number
$Partition = New-Partition -AssignDriveLetter -UseMaximumSize -DiskNumber $Disk.Number
Format-Volume -FileSystem NTFS -Confirm:$false -DriveLetter $Partition.DriveLetter -Force
$UniqueId = (Get-Volume -DriveLetter $($Partition.DriveLetter)).UniqueId
$Path = $Partition.DriveLetter + ":" + "\" + $ParentFolder

#Create a folder in root drive of the mounted VHDX
New-Item -Path $Path -ItemType Directory
Set-Volume -DriveLetter $Partition.DriveLetter -NewFileSystemLabel $VolumeName

#Expand MSIX
Set-Location $MSIXmgrPath
.\msixmgr.exe -Unpack -PackagePath $PackagePath -Destination $Path -ApplyACLs

#Show Unique ID
Write-Host "Unique ID: $UniqueId"

#Detach VHDX
Dismount-VHD $MSIXVhdxSrc -Passthru