﻿$MSIXVhdxSrc="\\mst.intra\dfs\MSIXAppAttach\VLC.VHDX"
$PackageName = "VLC-Player-3.0.11-x64_1.0.0.0_x64__cqfpzfs0pq22w"
$Parts = $PackageName.split("_")
$AppName = $Parts[0]
$VolumeName = "MSIX-" + $Parts[0]
$ParentFolder = "MSIX"    
$MSIXJunction = "C:\temp\AppAttach\" 

#Mount VHDX
try{
    Mount-Diskimage -ImagePath $MSIXVhdxSrc -NoDriveLetter -Access ReadOnly                 
    Write-Host ("Mounting of " + $MSIXVhdxSrc + " was completed!") -BackgroundColor Green 
}catch{
    Write-Host ("Mounting of " + $MSIXVhdxSrc + " has failed!") -BackgroundColor Red
}

#Create Link
$msixDest = (Get-Volume | Where-Object {$_.FileSystemLabel -eq "$VolumeName"}).UniqueId

if(!(Test-Path $MSIXJunction)){
    New-Item -Path "C:\" -Name "temp" -ItemType "Directory" -ErrorAction SilentlyContinue
    New-Item -Path "C:\temp" -Name "AppAttach" -ItemType "directory" -ErrorAction SilentlyContinue
    Write-Host "Junction Point created!"
}
$MSIXJunction = $MSIXJunction + $PackageName
CMD /C "mklink /j $MSIXJunction $msixDest"

#Staging
[Windows.Management.Deployment.PackageManager,Windows.Management.Deployment,ContentType=WindowsRuntime] | Out-Null
Add-Type -AssemblyName System.Runtime.WindowsRuntime

$asTask = ([System.WindowsRuntimeSystemExtensions].GetMethods() | Where { $_.ToString() -eq 'System.Threading.Tasks.Task`1[TResult] AsTask[TResult,TProgress](Windows.Foundation.IAsyncOperationWithProgress`2[TResult,TProgress])'})[0]
$asTaskAsyncOperation = $asTask.MakeGenericMethod([Windows.Management.Deployment.DeploymentResult], [Windows.Management.Deployment.DeploymentProgress])
$packageManager = [Windows.Management.Deployment.PackageManager]::new()
$path = $MSIXJunction + "\" + $ParentFolder + "\" + $PackageName
$path = ([System.Uri]$path).AbsoluteUri
$asyncOperation = $packageManager.StagePackageAsync($path, $null, "StageInPlace")                                                                                      
$task = $asTaskAsyncOperation.Invoke($null, @($asyncOperation))
$task